// 
// Erzeugt vom DataSnap-Proxy-Generator.
// 06.07.2016 09:22:05
// 

unit ClientClassesUnit1;

interface

uses System.JSON, Datasnap.DSProxyRest, Datasnap.DSClientRest, Data.DBXCommon, Data.DBXClient, Data.DBXDataSnap, Data.DBXJSON, Datasnap.DSProxy, System.Classes, System.SysUtils, Data.DB, Data.SqlExpr, Data.DBXDBReaders, Data.DBXCDSReaders, Data.DBXJSONReflect;

type
  TAdventureMethodsClient = class(TDSAdminRestClient)
  private
    FSendTextCommand: TDSRestCommand;
    FStartCommand: TDSRestCommand;
  public
    constructor Create(ARestConnection: TDSRestConnection); overload;
    constructor Create(ARestConnection: TDSRestConnection; AInstanceOwner: Boolean); overload;
    destructor Destroy; override;
    function SendText(ID: string; AText: string; out AResponse: string; out AIsRunning: Boolean; const ARequestFilter: string = ''): Boolean;
    function Start(out ID: string; out AResponse: string; out AIsRunning: Boolean; const ARequestFilter: string = ''): Boolean;
  end;

const
  TAdventureMethods_SendText: array [0..4] of TDSRestParameterMetaData =
  (
    (Name: 'ID'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'AText'; Direction: 1; DBXType: 26; TypeName: 'string'),
    (Name: 'AResponse'; Direction: 2; DBXType: 26; TypeName: 'string'),
    (Name: 'AIsRunning'; Direction: 2; DBXType: 4; TypeName: 'Boolean'),
    (Name: ''; Direction: 4; DBXType: 4; TypeName: 'Boolean')
  );

  TAdventureMethods_Start: array [0..3] of TDSRestParameterMetaData =
  (
    (Name: 'ID'; Direction: 2; DBXType: 26; TypeName: 'string'),
    (Name: 'AResponse'; Direction: 2; DBXType: 26; TypeName: 'string'),
    (Name: 'AIsRunning'; Direction: 2; DBXType: 4; TypeName: 'Boolean'),
    (Name: ''; Direction: 4; DBXType: 4; TypeName: 'Boolean')
  );

implementation

function TAdventureMethodsClient.SendText(ID: string; AText: string; out AResponse: string; out AIsRunning: Boolean; const ARequestFilter: string): Boolean;
begin
  if FSendTextCommand = nil then
  begin
    FSendTextCommand := FConnection.CreateCommand;
    FSendTextCommand.RequestType := 'GET';
    FSendTextCommand.Text := 'TAdventureMethods.SendText';
    FSendTextCommand.Prepare(TAdventureMethods_SendText);
  end;
  FSendTextCommand.Parameters[0].Value.SetWideString(ID);
  FSendTextCommand.Parameters[1].Value.SetWideString(AText);
  FSendTextCommand.Execute(ARequestFilter);
  AResponse := FSendTextCommand.Parameters[2].Value.GetWideString;
  AIsRunning := FSendTextCommand.Parameters[3].Value.GetBoolean;
  Result := FSendTextCommand.Parameters[4].Value.GetBoolean;
end;

function TAdventureMethodsClient.Start(out ID: string; out AResponse: string; out AIsRunning: Boolean; const ARequestFilter: string): Boolean;
begin
  if FStartCommand = nil then
  begin
    FStartCommand := FConnection.CreateCommand;
    FStartCommand.RequestType := 'GET';
    FStartCommand.Text := 'TAdventureMethods.Start';
    FStartCommand.Prepare(TAdventureMethods_Start);
  end;
  FStartCommand.Execute(ARequestFilter);
  ID := FStartCommand.Parameters[0].Value.GetWideString;
  AResponse := FStartCommand.Parameters[1].Value.GetWideString;
  AIsRunning := FStartCommand.Parameters[2].Value.GetBoolean;
  Result := FStartCommand.Parameters[3].Value.GetBoolean;
end;

constructor TAdventureMethodsClient.Create(ARestConnection: TDSRestConnection);
begin
  inherited Create(ARestConnection);
end;

constructor TAdventureMethodsClient.Create(ARestConnection: TDSRestConnection; AInstanceOwner: Boolean);
begin
  inherited Create(ARestConnection, AInstanceOwner);
end;

destructor TAdventureMethodsClient.Destroy;
begin
  FSendTextCommand.DisposeOf;
  FStartCommand.DisposeOf;
  inherited;
end;

end.
